module Data.IntMap where

(!) :: IntMap a -> Key -> a
data IntMap a
  = Data.IntMap.Nil
  | Data.IntMap.Tip !Key a
  | Data.IntMap.Bin !Data.IntMap.Prefix
                    !Data.IntMap.Mask
                    !(IntMap a)
                    !(IntMap a)
type Key = Int
(\\) :: IntMap a -> IntMap b -> IntMap a
adjust :: (a -> a) -> Key -> IntMap a -> IntMap a
adjustWithKey :: (Key -> a -> a) -> Key -> IntMap a -> IntMap a
alter :: (Maybe a -> Maybe a) -> Int -> IntMap a -> IntMap a
assocs :: IntMap a -> [(Key, a)]
delete :: Key -> IntMap a -> IntMap a
deleteFindMax :: IntMap a -> (a, IntMap a)
deleteFindMin :: IntMap a -> (a, IntMap a)
deleteMax :: IntMap a -> IntMap a
deleteMin :: IntMap a -> IntMap a
difference :: IntMap a -> IntMap b -> IntMap a
differenceWith ::
  (a -> b -> Maybe a) -> IntMap a -> IntMap b -> IntMap a
differenceWithKey ::
  (Key -> a -> b -> Maybe a) -> IntMap a -> IntMap b -> IntMap a
elems :: IntMap a -> [a]
empty :: IntMap a
filter :: (a -> Bool) -> IntMap a -> IntMap a
filterWithKey :: (Key -> a -> Bool) -> IntMap a -> IntMap a
findMax :: IntMap a -> (Int, a)
findMin :: IntMap a -> (Int, a)
findWithDefault :: a -> Key -> IntMap a -> a
fold :: (a -> b -> b) -> b -> IntMap a -> b
foldWithKey :: (Key -> a -> b -> b) -> b -> IntMap a -> b
fromAscList :: [(Key, a)] -> IntMap a
fromAscListWith :: (a -> a -> a) -> [(Key, a)] -> IntMap a
fromAscListWithKey ::
  (Key -> a -> a -> a) -> [(Key, a)] -> IntMap a
fromDistinctAscList :: [(Key, a)] -> IntMap a
fromList :: [(Key, a)] -> IntMap a
fromListWith :: (a -> a -> a) -> [(Key, a)] -> IntMap a
fromListWithKey :: (Key -> a -> a -> a) -> [(Key, a)] -> IntMap a
insert :: Key -> a -> IntMap a -> IntMap a
insertLookupWithKey ::
  (Key -> a -> a -> a) -> Key -> a -> IntMap a -> (Maybe a, IntMap a)
insertWith :: (a -> a -> a) -> Key -> a -> IntMap a -> IntMap a
insertWithKey ::
  (Key -> a -> a -> a) -> Key -> a -> IntMap a -> IntMap a
intersection :: IntMap a -> IntMap b -> IntMap a
intersectionWith ::
  (a -> b -> c) -> IntMap a -> IntMap b -> IntMap c
intersectionWithKey ::
  (Key -> a -> b -> c) -> IntMap a -> IntMap b -> IntMap c
isProperSubmapOf :: (Eq a) => IntMap a -> IntMap a -> Bool
isProperSubmapOfBy ::
  (a -> b -> Bool) -> IntMap a -> IntMap b -> Bool
isSubmapOf :: (Eq a) => IntMap a -> IntMap a -> Bool
isSubmapOfBy :: (a -> b -> Bool) -> IntMap a -> IntMap b -> Bool
keys :: IntMap a -> [Key]
keysSet :: IntMap a -> Data.IntSet.IntSet
lookup :: Key -> IntMap a -> Maybe a
map :: (a -> b) -> IntMap a -> IntMap b
mapAccum :: (a -> b -> (a, c)) -> a -> IntMap b -> (a, IntMap c)
mapAccumRWithKey ::
  (a -> Key -> b -> (a, c)) -> a -> IntMap b -> (a, IntMap c)
mapAccumWithKey ::
  (a -> Key -> b -> (a, c)) -> a -> IntMap b -> (a, IntMap c)
mapEither :: (a -> Either b c) -> IntMap a -> (IntMap b, IntMap c)
mapEitherWithKey ::
  (Key -> a -> Either b c) -> IntMap a -> (IntMap b, IntMap c)
mapMaybe :: (a -> Maybe b) -> IntMap a -> IntMap b
mapMaybeWithKey :: (Key -> a -> Maybe b) -> IntMap a -> IntMap b
mapWithKey :: (Key -> a -> b) -> IntMap a -> IntMap b
maxView :: IntMap a -> Maybe (a, IntMap a)
maxViewWithKey :: IntMap a -> Maybe ((Key, a), IntMap a)
member :: Key -> IntMap a -> Bool
minView :: IntMap a -> Maybe (a, IntMap a)
minViewWithKey :: IntMap a -> Maybe ((Key, a), IntMap a)
notMember :: Key -> IntMap a -> Bool
null :: IntMap a -> Bool
partition :: (a -> Bool) -> IntMap a -> (IntMap a, IntMap a)
partitionWithKey ::
  (Key -> a -> Bool) -> IntMap a -> (IntMap a, IntMap a)
showTree :: (Show a) => IntMap a -> String
showTreeWith :: (Show a) => Bool -> Bool -> IntMap a -> String
singleton :: Key -> a -> IntMap a
size :: IntMap a -> Int
split :: Key -> IntMap a -> (IntMap a, IntMap a)
splitLookup :: Key -> IntMap a -> (IntMap a, Maybe a, IntMap a)
toAscList :: IntMap a -> [(Key, a)]
toList :: IntMap a -> [(Key, a)]
union :: IntMap a -> IntMap a -> IntMap a
unionWith :: (a -> a -> a) -> IntMap a -> IntMap a -> IntMap a
unionWithKey ::
  (Key -> a -> a -> a) -> IntMap a -> IntMap a -> IntMap a
unions :: [IntMap a] -> IntMap a
unionsWith :: (a -> a -> a) -> [IntMap a] -> IntMap a
update :: (a -> Maybe a) -> Key -> IntMap a -> IntMap a
updateLookupWithKey ::
  (Key -> a -> Maybe a) -> Key -> IntMap a -> (Maybe a, IntMap a)
updateMax :: (a -> a) -> IntMap a -> IntMap a
updateMaxWithKey :: (Key -> a -> a) -> IntMap a -> IntMap a
updateMin :: (a -> a) -> IntMap a -> IntMap a
updateMinWithKey :: (Key -> a -> a) -> IntMap a -> IntMap a
updateWithKey ::
  (Key -> a -> Maybe a) -> Key -> IntMap a -> IntMap a
