module Data.Sequence where

(<|) :: a -> Seq a -> Seq a
(><) :: Seq a -> Seq a -> Seq a
newtype Seq a
  = Data.Sequence.Seq (Data.Sequence.FingerTree
                         (Data.Sequence.Elem a))
data ViewL a = EmptyL | a :< (Seq a)
data ViewR a = EmptyR | (Seq a) :> a
adjust :: (a -> a) -> Int -> Seq a -> Seq a
breakl :: (a -> Bool) -> Seq a -> (Seq a, Seq a)
breakr :: (a -> Bool) -> Seq a -> (Seq a, Seq a)
drop :: Int -> Seq a -> Seq a
dropWhileL :: (a -> Bool) -> Seq a -> Seq a
dropWhileR :: (a -> Bool) -> Seq a -> Seq a
elemIndexL :: (Eq a) => a -> Seq a -> Maybe Int
elemIndexR :: (Eq a) => a -> Seq a -> Maybe Int
elemIndicesL :: (Eq a) => a -> Seq a -> [Int]
elemIndicesR :: (Eq a) => a -> Seq a -> [Int]
empty :: Seq a
filter :: (a -> Bool) -> Seq a -> Seq a
findIndexL :: (a -> Bool) -> Seq a -> Maybe Int
findIndexR :: (a -> Bool) -> Seq a -> Maybe Int
findIndicesL :: (a -> Bool) -> Seq a -> [Int]
findIndicesR :: (a -> Bool) -> Seq a -> [Int]
foldlWithIndex :: (b -> Int -> a -> b) -> b -> Seq a -> b
foldrWithIndex :: (Int -> a -> b -> b) -> b -> Seq a -> b
fromList :: [a] -> Seq a
index :: Seq a -> Int -> a
inits :: Seq a -> Seq (Seq a)
iterateN :: Int -> (a -> a) -> a -> Seq a
length :: Seq a -> Int
mapWithIndex :: (Int -> a -> b) -> Seq a -> Seq b
null :: Seq a -> Bool
partition :: (a -> Bool) -> Seq a -> (Seq a, Seq a)
replicate :: Int -> a -> Seq a
replicateA ::
  (Control.Applicative.Applicative f) => Int -> f a -> f (Seq a)
replicateM :: (Monad m) => Int -> m a -> m (Seq a)
reverse :: Seq a -> Seq a
scanl :: (a -> b -> a) -> a -> Seq b -> Seq a
scanl1 :: (a -> a -> a) -> Seq a -> Seq a
scanr :: (a -> b -> b) -> b -> Seq a -> Seq b
scanr1 :: (a -> a -> a) -> Seq a -> Seq a
singleton :: a -> Seq a
sort :: (Ord a) => Seq a -> Seq a
sortBy :: (a -> a -> Ordering) -> Seq a -> Seq a
spanl :: (a -> Bool) -> Seq a -> (Seq a, Seq a)
spanr :: (a -> Bool) -> Seq a -> (Seq a, Seq a)
splitAt :: Int -> Seq a -> (Seq a, Seq a)
tails :: Seq a -> Seq (Seq a)
take :: Int -> Seq a -> Seq a
takeWhileL :: (a -> Bool) -> Seq a -> Seq a
takeWhileR :: (a -> Bool) -> Seq a -> Seq a
unfoldl :: (b -> Maybe (b, a)) -> b -> Seq a
unfoldr :: (b -> Maybe (a, b)) -> b -> Seq a
unstableSort :: (Ord a) => Seq a -> Seq a
unstableSortBy :: (a -> a -> Ordering) -> Seq a -> Seq a
update :: Int -> a -> Seq a -> Seq a
viewl :: Seq a -> ViewL a
viewr :: Seq a -> ViewR a
zip :: Seq a -> Seq b -> Seq (a, b)
zip3 :: Seq a -> Seq b -> Seq c -> Seq (a, b, c)
zip4 :: Seq a -> Seq b -> Seq c -> Seq d -> Seq (a, b, c, d)
zipWith :: (a -> b -> c) -> Seq a -> Seq b -> Seq c
zipWith3 ::
  (a -> b -> c -> d) -> Seq a -> Seq b -> Seq c -> Seq d
zipWith4 ::
  (a -> b -> c -> d -> e)
  -> Seq a
  -> Seq b
  -> Seq c
  -> Seq d
  -> Seq e
(|>) :: Seq a -> a -> Seq a
