module GHC.IO.Encoding where

latin1 :: TextEncoding
latin1_decode ::
  GHC.IO.Buffer.Buffer GHC.Word.Word8
  -> GHC.IO.Buffer.CharBuffer
  -> IO
       (GHC.IO.Buffer.Buffer GHC.Word.Word8, GHC.IO.Buffer.CharBuffer)
latin1_encode ::
  GHC.IO.Buffer.CharBuffer
  -> GHC.IO.Buffer.Buffer GHC.Word.Word8
  -> IO
       (GHC.IO.Buffer.CharBuffer, GHC.IO.Buffer.Buffer GHC.Word.Word8)
localeEncoding :: TextEncoding
mkTextEncoding :: String -> IO TextEncoding
utf16 :: TextEncoding
utf16be :: TextEncoding
utf16le :: TextEncoding
utf32 :: TextEncoding
utf32be :: TextEncoding
utf32le :: TextEncoding
utf8 :: TextEncoding
utf8_bom :: TextEncoding
data BufferCodec from to state
  = BufferCodec {encode :: GHC.IO.Buffer.Buffer from
                           -> GHC.IO.Buffer.Buffer to
                           -> IO (GHC.IO.Buffer.Buffer from, GHC.IO.Buffer.Buffer to),
                 close :: IO (),
                 getState :: IO state,
                 setState :: state -> IO ()}
type TextDecoder state =
  BufferCodec GHC.Word.Word8 GHC.IO.Buffer.CharBufElem state
type TextEncoder state =
  BufferCodec GHC.IO.Buffer.CharBufElem GHC.Word.Word8 state
data TextEncoding {-where
  TextEncoding :: forall dstate estate.
                  (IO (TextDecoder dstate)) -> (IO
                                                  (TextEncoder estate)) -> TextEncoding
-}