module GHC.IO.Exception where
data ArrayException
  = IndexOutOfBounds String | UndefinedElement String
data AssertionFailed = AssertionFailed String
data AsyncException
  = StackOverflow | HeapOverflow | ThreadKilled | UserInterrupt
data BlockedIndefinitelyOnMVar = BlockedIndefinitelyOnMVar
data BlockedIndefinitelyOnSTM = BlockedIndefinitelyOnSTM
data Deadlock = Deadlock
data ExitCode = ExitSuccess | ExitFailure Int
type IOError = IOException
data IOErrorType
  = AlreadyExists
  | NoSuchThing
  | ResourceBusy
  | ResourceExhausted
  | EOF
  | IllegalOperation
  | PermissionDenied
  | UserError
  | UnsatisfiedConstraints
  | SystemError
  | ProtocolError
  | OtherError
  | InvalidArgument
  | InappropriateType
  | HardwareFault
  | UnsupportedOperation
  | TimeExpired
  | ResourceVanished
  | Interrupted
data IOException
  = IOError {ioe_handle :: Maybe GHC.IO.Handle.Types.Handle,
             ioe_type :: IOErrorType,
             ioe_location :: String,
             ioe_description :: String,
             ioe_errno :: Maybe Foreign.C.Types.CInt,
             ioe_filename :: Maybe FilePath}
--assertError :: GHC.Prim.Addr# -> Bool -> a -> a
blockedIndefinitelyOnMVar :: GHC.Exception.SomeException
blockedIndefinitelyOnSTM :: GHC.Exception.SomeException
heapOverflow :: GHC.Exception.SomeException
ioError :: IOError -> IO a
ioException :: IOException -> IO a
stackOverflow :: GHC.Exception.SomeException
unsupportedOperation :: IOError
--untangle :: GHC.Prim.Addr# -> String -> String
userError :: String -> IOError
