module System.Console.Haskeline where
{-
defaultSettings :: (Control.Monad.Trans.MonadIO m) => Settings m
getInputChar ::
  (MonadException m) => String -> InputT m (Maybe Char)
getInputLine ::
  (MonadException m) => String -> InputT m (Maybe String)
handleInterrupt :: (MonadException m) => m a -> m a -> m a
outputStr ::
  (Control.Monad.Trans.MonadIO m) => String -> InputT m ()
outputStrLn ::
  (Control.Monad.Trans.MonadIO m) => String -> InputT m ()
withInterrupt :: (MonadException m) => InputT m a -> InputT m a
data Completion
  = Completion {replacement :: String,
                display :: String,
                isFinished :: Bool}
type CompletionFunc m =
  (String, String) -> m (String, [Completion])
newtype InputT m a
  = haskeline-0.6.2.2:System.Console.Haskeline.InputT.InputT {haskeline-0.6.2.2:System.Console.Haskeline.InputT.unInputT :: Control.Monad.Reader.ReaderT
                                                                                                                              haskeline-0.6.2.2:System.Console.Haskeline.Term.RunTerm
                                                                                                                              (Control.Monad.State.Lazy.StateT
                                                                                                                                 System.Console.Haskeline.History.History
                                                                                                                                 (Control.Monad.State.Lazy.StateT
                                                                                                                                    haskeline-0.6.2.2:System.Console.Haskeline.Command.KillRing.KillRing
                                                                                                                                    (Control.Monad.Reader.ReaderT
                                                                                                                                       Prefs
                                                                                                                                       (Control.Monad.Reader.ReaderT
                                                                                                                                          (Settings
                                                                                                                                             m)
                                                                                                                                          m))))
                                                                                                                              a}
data Interrupt = Interrupt
class (Control.Monad.Trans.MonadIO m) => MonadException m where
  System.Console.Haskeline.catch ::
    (Exception e) => m a -> (e -> m a) -> m a
  block :: m a -> m a
  unblock :: m a -> m a
data Prefs
  = haskeline-0.6.2.2:System.Console.Haskeline.Prefs.Prefs {haskeline-0.6.2.2:System.Console.Haskeline.Prefs.bellStyle :: !haskeline-0.6.2.2:System.Console.Haskeline.Prefs.BellStyle,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.editMode :: !haskeline-0.6.2.2:System.Console.Haskeline.Prefs.EditMode,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.maxHistorySize :: !Maybe
                                                                                                                                  Int,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.historyDuplicates :: haskeline-0.6.2.2:System.Console.Haskeline.Prefs.HistoryDuplicates,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.completionType :: !haskeline-0.6.2.2:System.Console.Haskeline.Prefs.CompletionType,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.completionPaging :: !Bool,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.completionPromptLimit :: !Maybe
                                                                                                                                         Int,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.listCompletionsImmediately :: !Bool,
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.customBindings :: Data.Map.Map
                                                                                                                                 haskeline-0.6.2.2:System.Console.Haskeline.Key.Key
                                                                                                                                 [haskeline-0.6.2.2:System.Console.Haskeline.Key.Key],
                                                            haskeline-0.6.2.2:System.Console.Haskeline.Prefs.customKeySequences :: [(Maybe
                                                                                                                                       String,
                                                                                                                                     String,
                                                                                                                                     haskeline-0.6.2.2:System.Console.Haskeline.Key.Key)]}
data Settings m
  = Settings {complete :: CompletionFunc m,
              historyFile :: Maybe FilePath,
              autoAddHistory :: Bool}
data SomeException where
  SomeException :: forall e. (Exception e) => e -> SomeException
data Settings m = Settings {..., autoAddHistory :: Bool}
bracket ::
  (MonadException m) => m a -> (a -> m b) -> (a -> m c) -> m c
data Settings m = Settings {complete :: CompletionFunc m, ...}
completeFilename ::
  (Control.Monad.Trans.MonadIO m) => CompletionFunc m
completeQuotedWord ::
  (Monad m) =>
  Maybe Char
  -> String
  -> (String -> m [Completion])
  -> CompletionFunc m
  -> CompletionFunc m
completeWord ::
  (Monad m) =>
  Maybe Char
  -> String
  -> (String -> m [Completion])
  -> CompletionFunc m
defaultPrefs :: Prefs
data Completion = Completion {..., display :: String, ...}
filenameWordBreakChars :: String
finally :: (MonadException m) => m a -> m b -> m a
handle ::
  (MonadException m, Exception e) => (e -> m a) -> m a -> m a
handleDyn ::
  (Exception exception, MonadException m) =>
  (exception -> m a) -> m a -> m a
data Settings m
  = Settings {..., historyFile :: Maybe FilePath, ...}
data Completion = Completion {..., isFinished :: Bool}
listFiles ::
  (Control.Monad.Trans.MonadIO m) => FilePath -> m [Completion]
noCompletion :: (Monad m) => CompletionFunc m
readPrefs :: FilePath -> IO Prefs
data Completion = Completion {replacement :: String, ...}
runInputT :: (MonadException m) => Settings m -> InputT m a -> m a
runInputTWithPrefs ::
  (MonadException m) => Prefs -> Settings m -> InputT m a -> m a
setComplete :: CompletionFunc m -> Settings m -> Settings m
simpleCompletion :: String -> Completion
throwDynIO ::
  (Exception exception, Control.Monad.Trans.MonadIO m) =>
  exception -> m a
throwIO :: (Control.Monad.Trans.MonadIO m, Exception e) => e -> m a
throwTo ::
  (Control.Monad.Trans.MonadIO m, Exception e) =>
  GHC.Conc.ThreadId -> e -> m ()
-}